#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
/*
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
*/
#include <pthread.h>

// Shared state between master process and threads
typedef struct state_s
{
  int start;
  int end;
  int sum;
  char c;
  
} STATE;

// Thread definition
void* runner(void  *param)
{
  STATE *s = param;

  // Sum up the numbers from start (inclusive) to end (exclusive)
  for (int i = s->start; i < s->end; ++i) {
    s->sum += i;
    printf("%c", s->c);
    fflush(stdout);
    sleep(1);
  };

  pthread_exit(0);
}


int main(int argc, char** argv)
{
  // Create the state for the threads
  STATE s1;
  s1.start = 2;
  s1.end = 5;
  s1.sum = 0;
  s1.c = '.';

  STATE s2;
  s2.start = 5;
  s2.end = 10;
  s2.sum = 0;
  s2.c = '#';

  pthread_t tid1;
  pthread_t tid2;
  pthread_attr_t attr;

  // Create the threads and start the work
  pthread_attr_init(&attr);
  pthread_create(&tid1, &attr, runner, &s1);

  pthread_create(&tid2, &attr, runner, &s2);

  // Wait for the threads to complete
  pthread_join(tid1, NULL);
  pthread_join(tid2, NULL);

  // Report the results
  printf("\nSUM: %d\n", s1.sum + s2.sum);
}
